/*
 * $Id: AbstractConnectorTypeRegistry.java,v 1.8 2005/10/13 12:37:26 windowsnt\martin Exp $
 * 
 * Copyright (C) ITC 2005 - International Institute for Geo-Information Science and Earth Observation
 *    
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package org.n52.connectors.core;

import java.util.HashMap;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;
import org.n52.connectors.core.exceptions.IllegalDefaultSettingException;


public abstract class AbstractConnectorTypeRegistry implements
		ConnectorTypeRegistry {
	
	AbstractConnectorTypeRegistry()
	{
		BasicConfigurator.configure();
		
	}
	/**
	 * Set a default connector for a specific service. If no provider is
	 * specified for a service the dfault will be choosen
	 * 
	 * @param serviceId
	 *            describes the service whose default connector is set
	 * @param connectorName
	 *            is the name of the default connector for this service
	 * @throws IllegalDefaultSettingException 
	 */
	public void setDefaultConnector(String serviceId, String connectorName) throws IllegalDefaultSettingException {
		if (defaultMapping == null)
			defaultMapping = new HashMap<String, String>(); 
		
		if ( serviceId.equals("") || connectorName.equals(""))
			throw new IllegalDefaultSettingException("Default settings : ServiceId = " + serviceId + ",connectorName=" + connectorName);

		defaultMapping.put(serviceId.toLowerCase(), connectorName.toLowerCase());

	}

	HashMap<String, String> defaultMapping = null;
	protected Logger logger = Logger.getLogger("org.52n.connectors.connectortyperegistry");
}
