package org.n52.connectors.core;

import java.io.IOException;
import java.io.StringReader;
import java.net.URL;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import org.n52.connectors.core.exceptions.IllegalConnectorRequest;
import org.n52.connectors.core.exceptions.N52Exception;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import com.sun.org.apache.xpath.internal.XPathAPI;

public abstract class AbstractFactory implements ConnectorCreation {

	public abstract Connector getConnector(ConnectorRequest request) throws IllegalConnectorRequest, N52Exception;

	public abstract Connector[] getConnectors(ConnectorRequest request);
	
	public void addRegistry(ConnectorTypeRegistry registry) {
		registries.add(registry);

	}

	public void addRegistry(URL location) {
		registries.add( new RemoteConnectorTypeRegistryProxy(location));

	}

	protected Document getClassInfo(String respons) throws SAXException, IOException, TransformerException, ParserConfigurationException {
         
		StringReader reader = new StringReader(respons);
		InputSource source = new InputSource(reader);
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();        
        DocumentBuilder build = factory.newDocumentBuilder();
        return  build.parse(source); 
  	}

	static public String getNodeValue(Node n, String tag) throws TransformerException {
		Node n2 = XPathAPI.selectSingleNode(n, tag + "/text()");
		return n2.getNodeValue();
	}
	
	protected ArrayList<ConnectorTypeRegistry> registries = new ArrayList<ConnectorTypeRegistry>();
}
