package org.n52.connectors.core;

import java.util.HashMap;

import org.n52.connectors.core.exceptions.ParameterDoesNotExist;

public class ConnectorRequest extends HashMap<String, Object> {
	/**
	 * 
	 */
	private static final long serialVersionUID = 2284089924224561238L;
	
	public ConnectorRequest() {
		put("connector", "default");
	}
	
	
	/**
	 * Gives a certain parameter a certain value. Predefined parametersId's  are
	 * service	: The name of the service you want to access
	 * connector : The specific implementation of a connector. optional; it normally chooses a predfined default
	 * source : defines a data source; can be local or on the web
	 * @param parameterId the name of the parameter
	 * @param value the value of the parameter
	 */
	public Object put(String parameterId, Object value){
		return super.put(parameterId, value);
	}
	
	/**
	 * Returns the value that is indicated by parameterId
	 * @param parameterId
	 * @return specific value as string
	 * @throws ParameterDoesNotExist if a parameter is asked that does not exist
	 */
	public Object get(String parameterId) throws ParameterDoesNotExist {
		if ( !containsKey(parameterId))
			throw new ParameterDoesNotExist("Parameter " + parameterId + " can not be found in the request");
		
		return super.get(parameterId);
	}
	

}
