/*
 * $Id: Operation.java,v 1.4 2005/10/13 12:37:26 windowsnt\martin Exp $
 * 
 * Copyright (C) ITC 2005 - International Institute for Geo-Information Science and Earth Observation
 *    
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package org.n52.connectors.core;

import java.util.Map;

import org.geotools.metadata.iso.MetadataEntity;

/**
 * All access to algorithms can be implemented using the Operation connector.
 * 
 * @author martin schouwenburg
 * 
 */
public interface Operation {
	/**
	 * Supports a particular operation defined by ( ...). The connector gives
	 * access to the requested operation though it may (and will in practice)
	 * support others.
	 * 
	 * @param inputData
	 *            contains all main data objects (e.g. coverages) that is need
	 *            for an operation to function.
	 * @param params
	 *            All secondary data objects that are needed for the operation
	 * @return All results in key/value combinations; this can be sued as input
	 *         for next operation connector
	 */
	Map execute(Map inputData, Map params);

	MetadataEntity getMetadata(String metadataTag);
}
