/*
 * $Id: WrappedException.java,v 1.5 2005/10/18 06:47:46 windowsnt\martin Exp $
 * 
 * Copyright (C) ITC 2005 - International Institute for Geo-Information Science and Earth Observation
 *    
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package org.n52.connectors.core.exceptions;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;

/**
 * Wrapper for non N52 exception to prevent a waterfall of exceptions generated by the framwork
 * @author martin schouwenburg
 *
 */
public class WrappedException extends N52Exception {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -5151967688348944737L;
	private Exception exception;

	
	public WrappedException(Exception ex, Logger logger, Level level) {
		exception = ex;
		logger.log(level, ex.getMessage());
		
	}
	
	public WrappedException(Exception ex) {
		exception = ex;
	}
	
	@Override
	public void printStackTrace()
	{
		exception.printStackTrace();
	}
	
}
