package org.n52.connectors.impl;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;

import javax.xml.transform.TransformerException;

import org.geotools.data.wfs.WFSDataStoreFactory;
import org.geotools.metadata.iso.MetadataEntity;
import org.n52.connectors.core.AbstractFactory;
import org.n52.connectors.core.AbstractFeatureConnector;
import org.n52.connectors.core.ConnectorRequest;
import org.n52.connectors.core.exceptions.IllegalConnectorRequest;
import org.n52.connectors.core.exceptions.ParameterDoesNotExist;
import org.w3c.dom.Document;

public class WFSConnector extends AbstractFeatureConnector {

	public WFSConnector() {
		connectorName = "itc.wfsconnector";
	}

	public MetadataEntity getMetadata(String s) {
		return null;
	}

	public boolean isSupported(ConnectorRequest request) {
		boolean canDo = false;
		try {
			 canDo = new String("gs.open.features").equalsIgnoreCase((String)request.get("service"));
			 URL source = new URL((String) request.get("resource"));
			 // naive check for being WFS. must be improved in the future
			 String query = source.getQuery();
			 if ( query.toLowerCase().lastIndexOf("getcapabilities") == -1)
				 canDo = false;
		} catch (ParameterDoesNotExist e) {
			canDo = false;
		} catch (MalformedURLException e) {
			canDo = false;
		}
		return canDo;
	}

	public void factorySideInitialization(Document xmlInit, ConnectorRequest request) throws IllegalConnectorRequest {
		HashMap<String, Object> parameters = new HashMap<String, Object>();

		try {
			Integer timeout = new Integer(10000);
			Boolean protocol = Boolean.FALSE;
			String source = "";
			
			try {source = (String) request.get("source");
			} catch (ParameterDoesNotExist e1) {}
			
			try { timeout = (Integer) request.get("timeout");
			} catch (ParameterDoesNotExist e) {}
			
			try { protocol = (Boolean) request.get("protocol");
			} catch (ParameterDoesNotExist e) {	}
			
			parameters.put(WFSDataStoreFactory.URL.key, source);
			parameters.put(WFSDataStoreFactory.TIMEOUT.key,
					new Integer(timeout));
			parameters.put(WFSDataStoreFactory.PROTOCOL.key, new Boolean(
					protocol));

			dataStore = (new WFSDataStoreFactory())
					.createNewDataStore(parameters);

		} catch (IOException e) {
			// throw new WrappedException(e);
		} 

	}
	
	public String registrySideInitialization(String returnXml, ConnectorRequest request)
	{
		return returnXml;
	}
}
