package org.n52.connectors.impl;

import org.geotools.data.DataStore;
import org.geotools.metadata.iso.MetadataEntity;
import org.n52.connectors.core.AbstractConnector;
import org.n52.connectors.core.ServiceRequest;

/**
 * Base implementation of access to features. Most connectors that give access
 * to features only need to define a datastore; this connector provides access
 * to the datastore. For more information about this interface see
 * www.geotools.org.
 * 
 * @author martin schouwenburg
 * 
 */
abstract public class FeatureConnector extends AbstractConnector {

	protected DataStore dataStore = null;

	/* (non-Javadoc)
	 * @see org.n52.connectors.core.Connector#getMetadata(java.lang.String)
	 */
	@Override
	abstract public MetadataEntity getMetadata(String s);

	/* (non-Javadoc)
	 * @see org.n52.connectors.core.Connector#isSupported(org.n52.connectors.core.ConnectorRequest)
	 */
	@Override
	abstract public boolean isSupported(ServiceRequest request);

	/* (non-Javadoc)
	 * @see org.n52.connectors.core.Connector#getImplementingObject(org.n52.connectors.core.ConnectorRequest)
	 */
	@Override
	public Object getImplementingObject(ServiceRequest request) {
		return dataStore;
	}
}