package org.n52.connectors.testcases;

import org.n52.connectors.core.ServiceRequest;
import org.n52.connectors.core.exceptions.ParameterDoesNotExistException;

import junit.framework.TestCase;

public class ConnectorRequestTester extends TestCase {
	// ask existing parameter
	public void testSetParameterCorrect() {
		try {
			ServiceRequest request = new ServiceRequest();
			String parm = "parameter";
			String val = "value";
			request.put(parm, val);
			String v = (String) request.get(parm);
			assertEquals(val, v);
		} catch (ParameterDoesNotExistException e) {
			assertTrue(false);
		}
	}
	
	// ask not existing parm
	public void testSetParameterUnCorrect() {
		try {
			ServiceRequest request = new ServiceRequest();
			String parm = "parameter";
			String val = "value";
			request.put(parm, val);
			String v = (String) request.get(parm + "a");
			assertEquals(val, v);
		} catch (ParameterDoesNotExistException e) {
			assertTrue(true);
		}
	}
}
