package org.n52.connectors.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.geotools.feature.Feature;
import org.n52.operation.gs.spatial.location.sort.AdjacencyListByGeometry;

import com.vividsolutions.jts.geom.Geometry;

public class N52Operation extends AbstractOperation {
 
	public N52Operation() {
		super();
	}
	
	@Override
	public Map execute(Map inputData, Map args) {
		
		if ( getQualifiedName().equalsIgnoreCase("gs.spatial.location.coord.select.adjacencybygeometry")) {
			return executeAdjacencyByGeometry(inputData, args);
		}
		return null;
	}

	private Map executeAdjacencyByGeometry(Map inputData, Map args) {
		AdjacencyListByGeometry adj = new AdjacencyListByGeometry();
		List<Feature> inputList = (List<Feature>) inputData.get("features");
		String method = (String) args.get("method");
		if ( method.equalsIgnoreCase("neighbourhood")) {
			adj.setMethod( AdjacencyListByGeometry.Methods.byNeighbourhood);
		}
		Geometry geom = (Geometry) args.get("anchor");
		adj.setAnchor(geom);
		
		String attrib = (String) args.get("attribute");
		adj.setAttribute(attrib);
		
		
		List<Feature> result = adj.getAdjecencyList(inputList);
		HashMap map = new HashMap();
		map.put("sortedlist", result);
		
		return map;
	}

}
