package org.n52.connectors.impl;

import java.util.ArrayList;

import org.geotools.metadata.iso.MetadataEntity;
import org.n52.connectors.core.AbstractConnector;
import org.n52.connectors.core.ServiceRequest;
import org.n52.connectors.core.exceptions.N52Exception;
import org.n52.connectors.core.exceptions.ParameterDoesNotExistException;

public class N52OperationConnector extends AbstractConnector {

	ArrayList<String> supportedOperations = new ArrayList<String>();
	

	/* (non-Javadoc)
	 * @see org.n52.connectors.core.Connector#isSupported(org.n52.connectors.core.ConnectorRequest)
	 */
	@Override
	public boolean isSupported(ServiceRequest req) {
		boolean canDo = false;
		try {
			for(String operation : supportedOperations) {
				canDo |= operation.equalsIgnoreCase((String) req.get("service"));
			}
			return canDo;
		} catch (ParameterDoesNotExistException e) {
			return false;
		}
	}

	/* (non-Javadoc)
	 * @see org.n52.connectors.core.Connector#registrySideInitialization(org.n52.connectors.core.ConnectorRequest)
	 */
	@Override
	public String registrySideInitialization(ServiceRequest request) {
		try {
			String service = (String) request.get("service");
			if ( service.equalsIgnoreCase(supportedOperations.get(0))) // adjacency
				return "<implementingclass>org.n52.connectors.impl.N52Operation</implementingclass>";
			return "";
		} catch (ParameterDoesNotExistException e) {
			return "";
		}
	}

	/* (non-Javadoc)
	 * @see org.n52.connectors.core.Connector#getMetadata(java.lang.String)
	 */
	@Override
	public MetadataEntity getMetadata(String arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see org.n52.connectors.core.Connector#getImplementingObject(org.n52.connectors.core.ConnectorRequest)
	 */
	@Override
	public Object getImplementingObject(ServiceRequest request)
			throws N52Exception {
		
		N52Operation op = (N52Operation) super.getImplementingObject(request);
		op.setQualifiedName( (String)request.get("service"));
		return op;
	}

	public N52OperationConnector() {
		super();
		supportedOperations.add("gs.spatial.location.coord.select.adjacencybygeometry");
	}

}
